/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/

    /*
     *CKTsetNodPm
     *
     *   set a parameter on a node.
     */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "acdefs.h"
#include "const.h"
#include "optdefs.h"
#include "devdefs.h"
#include "ifsim.h"
#include "iferrmsg.h"
#include "distodef.h"
#include "pzdefs.h"
#include "fteconst.h"
#include "tskdefs.h"
#include "trandefs.h"
#include "complex.h"
#include "jobdefs.h"
#include "spmatrix.h"
#include "tfdefs.h"
#include "noisedef.h"
#include "gendefs.h"
#include "opdefs.h"
#include "util.h"
#include "acdefs.h"
#include "misc.h"
#include "trcvdefs.h"
#include "strext.h"
#include "smpdefs.h"
#include "sensdefs.h"
#include "sensgen.h"
#include "sperror.h"
#include "suffix.h"
#pragma hdrstop
#ifdef HAS_FLAT_INCLUDES
#include "vsrcdefs.h"
#include "isrcdefs.h"
#else
#include "vsrc/vsrcdefs.h"
#include "isrc/isrcdefs.h"
#endif


/* ARGSUSED */
int
CKTsetNodPm(ckt,node,parm,value,selector)
    GENERIC *ckt;
    GENERIC *node;
    int parm;
    IFvalue *value;
    IFvalue *selector;

{
    if(!node) return(E_BADPARM);
    switch(parm) {

    case PARM_NS:
        ((CKTnode *)node)->nodeset = value->rValue;
        ((CKTnode *)node)->nsGiven = 1;
        break;

    case PARM_IC:
        ((CKTnode *)node)->ic = value->rValue;
        ((CKTnode *)node)->icGiven = 1;
        break;

    case PARM_NODETYPE:
        ((CKTnode *)node)->type = value->iValue;
        break;

    default:
        return(E_BADPARM);
    }
    return(OK);
}
