/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1988 Jaijeet S Roychowdhury
**********/

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "acdefs.h"
#include "const.h"
#include "optdefs.h"
#include "devdefs.h"
#include "ifsim.h"
#include "iferrmsg.h"
#include "distodef.h"
#include "pzdefs.h"
#include "fteconst.h"
#include "tskdefs.h"
#include "trandefs.h"
#include "complex.h"
#include "jobdefs.h"
#include "spmatrix.h"
#include "tfdefs.h"
#include "noisedef.h"
#include "gendefs.h"
#include "opdefs.h"
#include "util.h"
#include "acdefs.h"
#include "misc.h"
#include "trcvdefs.h"
#include "strext.h"
#include "smpdefs.h"
#include "sensdefs.h"
#include "sensgen.h"
#include "sperror.h"
#include "suffix.h"
#pragma hdrstop
#ifdef HAS_FLAT_INCLUDES
#include "vsrcdefs.h"
#include "isrcdefs.h"
#else
#include "vsrc/vsrcdefs.h"
#include "isrc/isrcdefs.h"
#endif

int
DkerProc(type,rPtr,iPtr,size,job)
double *rPtr;
double *iPtr;
int size;
DISTOAN* job;
int type;

{
int i;
double temp;

switch(type) {

  case D_F1:


    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 2.0; /* convert to sinusoid amplitude */
	rPtr[i] *= 2.0;
	}

    break;

  case D_F2:


    for (i=1;i<=size;i++)
	{
	rPtr[i] *= 2.0;
        iPtr[i] *= 2.0;
	}

   break;

 case D_TWOF1:

    
    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 2.0;
	rPtr[i] *= 2.0;
	}

   break;

 case D_THRF1:


    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 2.0;
	rPtr[i] *= 2.0;
	}

    break;

 case D_F1PF2:


    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 4.0;
	rPtr[i] *= 4.0;
	}

    break;

 case D_F1MF2:

    
    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 4.0;
	rPtr[i] *= 4.0;
	}

    break;

 case D_2F1MF2:

    for (i=1;i<=size;i++)
	{
	iPtr[i] *= 6.0;
	rPtr[i] *= 6.0;
	}

    break;

 default:

	return(E_BADPARM);

}

return(OK);
}
